<?php
/** 
Plugin Name: A2 - WooCommerce CF & PI
Description: Aggiungo il campo codice fiscale e partita iva al checkout
Version: 1.0
Author: Alessio Angeloro
Author URI: http://www.alessioangeloro.it
License: GPL2
*/

//creo il campo codice fiscale
add_filter( 'woocommerce_checkout_fields' , 'codice_fiscale' );
 
function codice_fiscale( $fields ) {
     $fields['billing']['codice_fiscale'] = array(
    'label'     => __('Codice Fiscale', 'woocommerce'),
    'placeholder'   => _x('Codice Fiscale', 'placeholder', 'woocommerce'),
    'required'  => true,
    'class'     => array('form-row-last'),
    'clear'     => true
     );
 
     return $fields;
}
 
add_action( 'woocommerce_checkout_update_order_meta', 'codice_fiscale_order_meta' );
 
function codice_fiscale_order_meta( $order_id ) {
    if ( ! empty( $_POST['codice_fiscale'] ) ) {
        update_post_meta( $order_id, 'Codice Fiscale', sanitize_text_field( $_POST['codice_fiscale'] ) );
    }
}

//inserisco il codice fiscale nel back end
add_action( 'woocommerce_admin_order_data_after_billing_address', 'codice_fiscale_order_meta_admin', 10, 1 );
 
function codice_fiscale_order_meta_admin($order){
    echo '<p><strong>'.__('Codice Fiscale').':</strong> ' . get_post_meta( $order->id, 'Codice Fiscale', true ) . '</p>';
}

//inserisco il codice fiscale nella mail dell'ordine
add_filter('woocommerce_email_order_meta_keys', 'my_custom_fiscale_order_meta_keys');
 
function my_custom_fiscale_order_meta_keys( $keys ) {
    $keys[] = 'Codice Fiscale';
    return $keys;
}

//controllo che il codice fiscale sia compilato
add_action('woocommerce_checkout_process', 'required_cf_checkout_field_process');
 
function required_cf_checkout_field_process() {
    if ( ! $_POST['codice_fiscale'] )
        wc_add_notice( __( 'Compila il campo Codice Fiscale .' ), 'error' );
}

//creo il campo partita iva
add_filter( 'woocommerce_checkout_fields' , 'partita_iva' );
 
function partita_iva( $fields ) {
     $fields['billing']['partita_iva'] = array(
    'label'     => __('Partita Iva', 'woocommerce'),
    'placeholder'   => _x('Partita Iva', 'placeholder', 'woocommerce'),
    'required'  => true,
    'class'     => array('form-row-last'),
    'clear'     => true
     );
 
     return $fields;
}
 
add_action( 'woocommerce_checkout_update_order_meta', 'partita_iva_order_meta' );
 
function partita_iva_order_meta( $order_id ) {
    if ( ! empty( $_POST['partita_iva'] ) ) {
        update_post_meta( $order_id, 'Partita Iva', sanitize_text_field( $_POST['partita_iva'] ) );
    }
}

//inserisco il partita iva nel back end
add_action( 'woocommerce_admin_order_data_after_billing_address', 'partita_iva_order_meta_admin', 10, 1 );
 
function partita_iva_order_meta_admin($order){
    echo '<p><strong>'.__('Partita Iva').':</strong> ' . get_post_meta( $order->id, 'Partita Iva', true ) . '</p>';
}

//inserisco il partita iva nella mail dell'ordine
add_filter('woocommerce_email_order_meta_keys', 'my_custom_partita_iva_order_meta_keys');
 
function my_custom_partita_iva_order_meta_keys( $keys ) {
    $keys[] = 'Partita Iva';
    return $keys;
}

//controllo che il partita iva sia compilato
add_action('woocommerce_checkout_process', 'required_pi_checkout_field_process');
 
function required_pi_checkout_field_process() {
    if ( ! $_POST['partita_iva'] )
        wc_add_notice( __( 'Compila il campo Partita Iva .' ), 'error' );
}